import store from '@/store'
import config from '@/config'
import errorCode from '@/utils/errorCode'
import { toast, showConfirm, tansParams } from '@/utils/common'
import AES from '@/utils/aes'

let timeout = 100000
let baseUrl = config.baseUrl 

const request = config => {
  // 是否需要设置 token
  const isToken = (config.headers || {}).isToken === false
  config.header = config.headers || {}

  if (uni.getStorageSync('token') && !isToken) {
    config.header['Authorization'] = 'Bearer ' + uni.getStorageSync('token')
  }
  // get请求映射params参数
  // if (config.params) {
  //   let url = config.url + '?' + tansParams(config.params)
  //   url = url.slice(0, -1)
  //   config.url = url
  // }
  if (config.method == 'get' && config.params) {
    let param = tansParams(config.params)
    if (param) {
      param = param.slice(0, -1)
      // param = AES.encryptCBC(param)
    }
    // console.log('?? ~ file: request.js ~ line 108 ~ request ~ config.params', config.params)
    let url = config.url + '?' + param
    config.url = url
	config.header = {
			// "custId": uni.getStorageSync('custId'),
			// "openid": uni.getStorageSync('openId'),
			// "merchant-id":"378915229716713472",
			// "source-type": 7,
			// "sourceType": "7",
	  ...config.header
	}
  }
  // post请求
  if (config.method === 'post') {
    if (config.header.isForm) {
      config.header = {
        ...config.header,
        'Content-Type': 'application/x-www-form-urlencoded'
      }
    } else {
      config.header = {
		// "custId": uni.getStorageSync('custId'),
		// "openid": uni.getStorageSync('openId'),
		// "merchant-id":"378915229716713472",
		// "source-type": 7,
		// "sourceType": "7",
        ...config.header
      }
    }

    // config.data = AES.encryptCBC(JSON.stringify(config.data))
  }
  // put请求
  if (config.method === 'put' && config.data) {
    config.header = {
      ...config.header
    }
    // config.data = AES.encryptCBC(JSON.stringify(config.data))
  } else if (config.method === 'put' && config.params) {
    let params = tansParams(config.params)
    // params = AES.encryptCBC(params)
    config.url = config.url + '?' + params
  }
  // delete请求
  if (config.method === 'delete') {
    config.header = {
      ...config.header
    }
    // config.data = AES.encryptCBC(JSON.stringify(config.data))
  }
  // post请求参数加密
  // if (config.headers && config.headers['Content-Type'] == 'application/json') {
  //   if (typeof config.data == 'object') {
  //     // config.data = AES.encryptCBC(JSON.stringify(config.data))
  //   }
  // }
  //对下载请求进行数据参数拦截加密
  // if (config.headers && config.headers['Content-Type'] == 'application/x-www-form-urlencoded') {
  //   if (typeof config.data == 'object') {
  //     // console.log(config.data)
  //     let formData = tansParams(config.data)
  //     if (formData) {
  //       formData = formData.slice(0, -1)
  //       let formdata = {}
  //       formdata.formData = AES.encryptCBC(formData)
  //       config.data = formdata
  //     }
  //   } else {
  //     config.data = 'formData=' + AES.encryptCBC(JSON.stringify(config.data))
  //   }
  // }
  return new Promise((resolve, reject) => {
    uni.request({
        method: config.method || 'get',
        timeout: config.timeout || timeout,
        url: config.baseUrl || baseUrl + config.url,
        data: config.data,
        header: config.header,
        dataType: 'json'
      }).then(response => {
		  // console.log(response)
        let [error, res] = response
        if (error) {
          toast('连接异常')
          reject('连接异常')
          return
        }
        // res = JSON.parse(decryptCBC(res.data))
        console.log('?? ~ request.js ~ line 100 ~ res', res)
        const code = res.data.code || 200
        console.log('?? ~  ~ code', code)
        const msg = errorCode[code] || res.data.msg || errorCode['default']
        console.log('?? ~  ~ msg', msg)
        if (code === 401) {
          showConfirm('登录状态已过期，您可以继续留在该页面，或者重新登录?').then(res => {
            if (res.confirm) {
              store.dispatch('LogOut').then(res => {
                uni.reLaunch({ url: '/pages/login' })
              })
            }
          })
          reject('无效的会话，或者会话已过期，请重新登录。')
        } else if (code === 500) {
          toast(msg)
          reject('500')
        } else if (code === 10000) {
          resolve(res.data)
        } else if (code !== 200 && code !== 10000) {
          toast(msg)
          reject(code)
        }
        resolve(res.data)
      })
      .catch(error => { 
        let { message } = error
        if (message === 'Network Error') {
          message = '网络连接异常'
        } else if (message.includes('timeout')) {
          message = '系统接口请求超时'
        } else if (message.includes('Request failed with status code')) {
          message = '系统接口' + message.substr(message.length - 3) + '异常'
        }
        toast(message)
        reject(error)
      })
  })
}

export default request
